Gtk::CellRenderer Class Reference
TreeView Classes

CellRenderers are used by Gtk::TreeView columns to render the Gtk::TreeModel column data appropriately. More...

Inheritance diagram for Gtk::CellRenderer:
[legend]

## Public Member Functions

virtual | ~CellRenderer ()
GtkCellRenderer* | gobj ()
| Provides access to the underlying C GtkObject. More...
const GtkCellRenderer* | gobj () const
| Provides access to the underlying C GtkObject. More...
SizeRequestMode | get_request_mode () const
| Gets whether the cell renderer prefers a height-for-width layout or a width-for-height layout. More...
void | get_preferred_width (Widget& widget, int& minimum_width, int& natural_width) const
| Retreives a renderer's natural size when rendered to widget. More...
void | get_preferred_height_for_width (Widget& widget, int width, int& minimum_height, int& natural_height) const
| Retreives a cell renderers's minimum and natural height if it were rendered to widget with the specified width. More...
void | get_preferred_height (Widget& widget, int& minimum_height, int& natural_height) const
| Retreives a renderer's natural size when rendered to widget. More...
void | get_preferred_width_for_height (Widget& widget, int height, int& minimum_width, int& natural_width) const
| Retreives a cell renderers's minimum and natural width if it were rendered to widget with the specified height. More...
void | get_preferred_size (Widget& widget, Requisition& minimum_size, Requisition& natural_size) const
| Retrieves the minimum and natural size of a cell taking into account the widget's preference for height-for-width management. More...
void | get_aligned_area (Widget& widget, CellRendererState flags, const Gdk::Rectangle& cell_area, Gdk::Rectangle& aligned_area)
| Gets the aligned area used by cell inside cell_area. More...
void | render (const ::Cairo::RefPtr< ::Cairo::Context >& cr, Widget& widget, const Gdk::Rectangle& background_area, const Gdk::Rectangle& cell_area, CellRendererState flags)
| Invokes the virtual render function of the Gtk::CellRenderer. More...
bool | activate (GdkEvent* event, Widget& widget, const Glib::ustring& path, const Gdk::Rectangle& background_area, const Gdk::Rectangle& cell_area, CellRendererState flags)
| Passes an activate event to the cell renderer for possible processing. More...
CellEditable* | start_editing (GdkEvent* event, Widget& widget, const Glib::ustring& path, const Gdk::Rectangle& background_area, const Gdk::Rectangle& cell_area, CellRendererState flags=CellRendererState(0))
| Passes an activate event to the cell renderer for possible processing. More...
void | set_fixed_size (int width, int height)
| Sets the renderer size to be explicit, independent of the properties set. More...
void | get_fixed_size (int& width, int& height) const
| Fills in width and height with the appropriate size of cell. More...
void | set_alignment (float xalign, float yalign)
| Sets the renderer's alignment within its available space. More...
void | get_alignment (float& xalign, float& yalign) const
| Fills in xalign and yalign with the appropriate values of cell. More...
void | set_padding (int xpad, int ypad)
| Sets the renderer's padding. More...
void | get_padding (int& xpad, int& ypad) const
| Fills in xpad and ypad with the appropriate values of cell. More...
void | set_visible (bool visible=true)
| Sets the cell renderer's visibility. More...
bool | get_visible () const
| Returns the cell renderer's visibility. More...
void | set_sensitive (bool sensitive=true)
| Sets the cell renderer's sensitivity. More...
bool | get_sensitive () const
| Returns the cell renderer's sensitivity. More...
bool | is_activatable () const
| Checks whether the cell renderer can do something when activated. More...
void | stop_editing (bool canceled=false)
| Informs the cell renderer that the editing is stopped. More...
StateFlags | get_state (Widget& widget, CellRendererState cell_state) const
| Translates the cell renderer state to Gtk::StateFlags, based on the cell renderer and widget sensitivity, and the given Gtk::CellRendererState. More...
StateFlags | get_state (CellRendererState cell_state) const
| Translates the cell renderer state to StateFlags, based on the cell renderer and the given CellRendererState. More...
Glib::SignalProxy0< void > | signal_editing_canceled ()
Glib::SignalProxy2< void, CellEditable*, const Glib::ustring& > | signal_editing_started ()
| Note that this signal does not work yet in gtkmm. More...
Glib::PropertyProxy < CellRendererMode > | property_mode ()
| Editable mode of the CellRenderer. More...
Glib::PropertyProxy_ReadOnly < CellRendererMode > | property_mode () const
| Editable mode of the CellRenderer. More...
Glib::PropertyProxy< bool > | property_visible ()
| Display the cell. More...
Glib::PropertyProxy_ReadOnly < bool > | property_visible () const
| Display the cell. More...
Glib::PropertyProxy< bool > | property_sensitive ()
| Display the cell sensitive. More...
Glib::PropertyProxy_ReadOnly < bool > | property_sensitive () const
| Display the cell sensitive. More...
Glib::PropertyProxy< float > | property_xalign ()
| The x-align. More...
Glib::PropertyProxy_ReadOnly < float > | property_xalign () const
| The x-align. More...
Glib::PropertyProxy< float > | property_yalign ()
| The y-align. More...
Glib::PropertyProxy_ReadOnly < float > | property_yalign () const
| The y-align. More...
Glib::PropertyProxy< unsigned int > | property_xpad ()
| The xpad. More...
Glib::PropertyProxy_ReadOnly < unsigned int > | property_xpad () const
| The xpad. More...
Glib::PropertyProxy< unsigned int > | property_ypad ()
| The ypad. More...
Glib::PropertyProxy_ReadOnly < unsigned int > | property_ypad () const
| The ypad. More...
Glib::PropertyProxy< int > | property_width ()
| The fixed width. More...
Glib::PropertyProxy_ReadOnly< int > | property_width () const
| The fixed width. More...
Glib::PropertyProxy< int > | property_height ()
| The fixed height. More...
Glib::PropertyProxy_ReadOnly< int > | property_height () const
| The fixed height. More...
Glib::PropertyProxy< bool > | property_is_expander ()
| Row has children. More...
Glib::PropertyProxy_ReadOnly < bool > | property_is_expander () const
| Row has children. More...
Glib::PropertyProxy< bool > | property_is_expanded ()
| Row is an expander row, and is expanded. More...
Glib::PropertyProxy_ReadOnly < bool > | property_is_expanded () const
| Row is an expander row, and is expanded. More...
Glib::PropertyProxy_WriteOnly < Glib::ustring > | property_cell_background ()
| Cell background color as a string. More...
Glib::PropertyProxy< Gdk::Color > | property_cell_background_gdk ()
| Cell background color as a GdkColor. More...
Glib::PropertyProxy_ReadOnly < Gdk::Color > | property_cell_background_gdk () const
| Cell background color as a GdkColor. More...
Glib::PropertyProxy< Gdk::RGBA > | property_cell_background_rgba ()
| Cell background color as a GdkRGBA. More...
Glib::PropertyProxy_ReadOnly < Gdk::RGBA > | property_cell_background_rgba () const
| Cell background color as a GdkRGBA. More...
Glib::PropertyProxy< bool > | property_cell_background_set ()
| Whether the cell background color is set. More...
Glib::PropertyProxy_ReadOnly < bool > | property_cell_background_set () const
| Whether the cell background color is set. More...
Glib::PropertyProxy_ReadOnly < bool > | property_editing () const
| Whether the cell renderer is currently in editing mode. More...
Public Member Functions inherited from Gtk::Object
virtual | ~Object ()
GObject* | gobj ()
| Provides access to the underlying C GtkObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GtkObject. More...

## Static Public Member Functions

static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions

virtual void | on_editing_canceled ()
| This is a default handler for the signal signal_editing_canceled(). More...
virtual void | on_editing_started (CellEditable* editable, const Glib::ustring& path)
| This is a default handler for the signal signal_editing_started(). More...
| CellRenderer ()
virtual SizeRequestMode | get_request_mode_vfunc () const
virtual void | get_preferred_width_vfunc (Widget& widget, int& minimum_width, int& natural_width) const
virtual void | get_preferred_height_for_width_vfunc (Widget& widget, int width, int& minimum_height, int& natural_height) const
virtual void | get_preferred_height_vfunc (Widget& widget, int& minimum_height, int& natural_height) const
virtual void | get_preferred_width_for_height_vfunc (Widget& widget, int height, int& minimum_width, int& natural_width) const
virtual void | render_vfunc (const ::Cairo::RefPtr< ::Cairo::Context >& cr, Widget& widget, const Gdk::Rectangle& background_area, const Gdk::Rectangle& cell_area, CellRendererState flags)
virtual bool | activate_vfunc (GdkEvent* event, Widget& widget, const Glib::ustring& path, const Gdk::Rectangle& background_area, const Gdk::Rectangle& cell_area, CellRendererState flags)
virtual CellEditable* | start_editing_vfunc (GdkEvent* event, Widget& widget, const Glib::ustring& path, const Gdk::Rectangle& background_area, const Gdk::Rectangle& cell_area, CellRendererState flags)

## Related Functions

(Note that these are not member functions.)
Gtk::CellRenderer* | wrap (GtkCellRenderer* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

CellRenderers are used by Gtk::TreeView columns to render the Gtk::TreeModel column data appropriately.

They display, and allow editing of, the values of their properties. In most cases, Gtk::TreeView::append_column() will automatically choose the appropriate renderer for the mode column's data type, so you will rarely need to worry about these classes.

## Constructor & Destructor Documentation

virtual Gtk::CellRenderer::~CellRenderer | ( |  | ) |

virtual

Gtk::CellRenderer::CellRenderer | ( |  | ) |

protected

## Member Function Documentation

bool Gtk::CellRenderer::activate | ( | GdkEvent * | event,
|  | Widget& | widget,
|  | const Glib::ustring & | path,
|  | const Gdk::Rectangle& | background_area,
|  | const Gdk::Rectangle& | cell_area,
|  | CellRendererState | flags
| ) |  |

Passes an activate event to the cell renderer for possible processing.

Some cell renderers may use events; for example, Gtk::CellRendererToggle toggles when it gets a mouse click.

Parameters

  event | A Gdk::Event.
  widget | Widget that received the event.
  path | Widget-dependent string representation of the event location; e.g. for Gtk::TreeView, a string representation of Gtk::TreePath.
  background_area | Background area as passed to render().
  cell_area | Cell area as passed to render().
  flags | Render flags.

Returns
  `true` if the event was consumed/handled.

virtual bool Gtk::CellRenderer::activate_vfunc | ( | GdkEvent * | event,
|  | Widget& | widget,
|  | const Glib::ustring & | path,
|  | const Gdk::Rectangle& | background_area,
|  | const Gdk::Rectangle& | cell_area,
|  | CellRendererState | flags
| ) |  |

protected virtual

void Gtk::CellRenderer::get_aligned_area | ( | Widget& | widget,
|  | CellRendererState | flags,
|  | const Gdk::Rectangle& | cell_area,
|  | Gdk::Rectangle& | aligned_area
| ) |  |

Gets the aligned area used by cell inside cell_area.

Used for finding the appropriate edit and focus rectangle.

Since gtkmm 3.0:

Parameters

  widget | The Gtk::Widget this cell will be rendering to.
  flags | Render flags.
  cell_area | Cell area which would be passed to render().
  aligned_area | The return location for the space inside cell_area that would acually be used to render.

void Gtk::CellRenderer::get_alignment | ( | float & | xalign,
|  | float & | yalign
| ) |  | const

Fills in xalign and yalign with the appropriate values of cell.

Since gtkmm 2.18:

Parameters

  xalign | Location to fill in with the x alignment of the cell, or `0`.
  yalign | Location to fill in with the y alignment of the cell, or `0`.

void Gtk::CellRenderer::get_fixed_size | ( | int & | width,
|  | int & | height
| ) |  | const

Fills in width and height with the appropriate size of cell.

Parameters

  width | Location to fill in with the fixed width of the widget.
  height | Location to fill in with the fixed height of the widget.

void Gtk::CellRenderer::get_padding | ( | int & | xpad,
|  | int & | ypad
| ) |  | const

Fills in xpad and ypad with the appropriate values of cell.

Since gtkmm 2.18:

Parameters

  xpad | Location to fill in with the x padding of the cell, or `0`.
  ypad | Location to fill in with the y padding of the cell, or `0`.

void Gtk::CellRenderer::get_preferred_height | ( | Widget& | widget,
|  | int & | minimum_height,
|  | int & | natural_height
| ) |  | const

Retreives a renderer's natural size when rendered to widget.

Since gtkmm 3.0:

Parameters

  widget | The Gtk::Widget this cell will be rendering to.
  minimum_size | Location to store the minimum size, or `0`.
  natural_size | Location to store the natural size, or `0`.

void Gtk::CellRenderer::get_preferred_height_for_width | ( | Widget& | widget,
|  | int | width,
|  | int & | minimum_height,
|  | int & | natural_height
| ) |  | const

Retreives a cell renderers's minimum and natural height if it were rendered to widget with the specified width.

Since gtkmm 3.0:

Parameters

  widget | The Gtk::Widget this cell will be rendering to.
  width | The size which is available for allocation.
  minimum_height | Location for storing the minimum size, or `0`.
  natural_height | Location for storing the preferred size, or `0`.

virtual void Gtk::CellRenderer::get_preferred_height_for_width_vfunc | ( | Widget& | widget,
|  | int | width,
|  | int & | minimum_height,
|  | int & | natural_height
| ) |  | const

protected virtual

virtual void Gtk::CellRenderer::get_preferred_height_vfunc | ( | Widget& | widget,
|  | int & | minimum_height,
|  | int & | natural_height
| ) |  | const

protected virtual

void Gtk::CellRenderer::get_preferred_size | ( | Widget& | widget,
|  | Requisition& | minimum_size,
|  | Requisition& | natural_size
| ) |  | const

Retrieves the minimum and natural size of a cell taking into account the widget's preference for height-for-width management.

Since gtkmm 3.0:

Parameters

  widget | The Gtk::Widget this cell will be rendering to.
  minimum_size | Location for storing the minimum size, or `0`.
  natural_size | Location for storing the natural size, or `0`.

void Gtk::CellRenderer::get_preferred_width | ( | Widget& | widget,
|  | int & | minimum_width,
|  | int & | natural_width
| ) |  | const

Retreives a renderer's natural size when rendered to widget.

Since gtkmm 3.0:

Parameters

  widget | The Gtk::Widget this cell will be rendering to.
  minimum_size | Location to store the minimum size, or `0`.
  natural_size | Location to store the natural size, or `0`.

void Gtk::CellRenderer::get_preferred_width_for_height | ( | Widget& | widget,
|  | int | height,
|  | int & | minimum_width,
|  | int & | natural_width
| ) |  | const

Retreives a cell renderers's minimum and natural width if it were rendered to widget with the specified height.

Since gtkmm 3.0:

Parameters

  widget | The Gtk::Widget this cell will be rendering to.
  height | The size which is available for allocation.
  minimum_width | Location for storing the minimum size, or `0`.
  natural_width | Location for storing the preferred size, or `0`.

virtual void Gtk::CellRenderer::get_preferred_width_for_height_vfunc | ( | Widget& | widget,
|  | int | height,
|  | int & | minimum_width,
|  | int & | natural_width
| ) |  | const

protected virtual

virtual void Gtk::CellRenderer::get_preferred_width_vfunc | ( | Widget& | widget,
|  | int & | minimum_width,
|  | int & | natural_width
| ) |  | const

protected virtual

SizeRequestMode Gtk::CellRenderer::get_request_mode | ( |  | ) | const

Gets whether the cell renderer prefers a height-for-width layout or a width-for-height layout.

Since gtkmm 3.0:

Returns
  The Gtk::SizeRequestMode preferred by this renderer.

virtual SizeRequestMode Gtk::CellRenderer::get_request_mode_vfunc | ( |  | ) | const

protected virtual

bool Gtk::CellRenderer::get_sensitive | ( |  | ) | const

Returns the cell renderer's sensitivity.

Since gtkmm 2.18:

Returns
  `true` if the cell renderer is sensitive.

StateFlags Gtk::CellRenderer::get_state | ( | Widget& | widget,
|  | CellRendererState | cell_state
| ) |  | const

Translates the cell renderer state to Gtk::StateFlags, based on the cell renderer and widget sensitivity, and the given Gtk::CellRendererState.

Since gtkmm 3.0:

Parameters

  widget | A Gtk::Widget, or `0`.
  cell_state | Cell renderer state.

Returns
  The widget state flags applying to cell.

StateFlags Gtk::CellRenderer::get_state | ( | CellRendererState | cell_state | ) | const

Translates the cell renderer state to StateFlags, based on the cell renderer and the given CellRendererState.

Parameters

  cell_state | The cell renderer state.

Returns
  The widget state flags applying to the cell renderer.

Since gtkmm 3.0:

static GType Gtk::CellRenderer::get_type | ( |  | ) |

static

Get the GType for this class, for use with the underlying GObject type system.

bool Gtk::CellRenderer::get_visible | ( |  | ) | const

Returns the cell renderer's visibility.

Since gtkmm 2.18:

Returns
  `true` if the cell renderer is visible.

GtkCellRenderer* Gtk::CellRenderer::gobj | ( |  | ) |

inline

Provides access to the underlying C GtkObject.

const GtkCellRenderer* Gtk::CellRenderer::gobj | ( |  | ) | const

inline

Provides access to the underlying C GtkObject.

bool Gtk::CellRenderer::is_activatable | ( |  | ) | const

Checks whether the cell renderer can do something when activated.

Since gtkmm 3.0:

Returns
  `true` if the cell renderer can do anything when activated.

virtual void Gtk::CellRenderer::on_editing_canceled | ( |  | ) |

protected virtual

This is a default handler for the signal signal_editing_canceled().

virtual void Gtk::CellRenderer::on_editing_started | ( | CellEditable* | editable,
|  | const Glib::ustring & | path
| ) |  |

protected virtual

This is a default handler for the signal signal_editing_started().

Glib::PropertyProxy_WriteOnly< Glib::ustring > Gtk::CellRenderer::property_cell_background | ( |  | ) |

Cell background color as a string.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_WriteOnly that allows you to set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< Gdk::Color > Gtk::CellRenderer::property_cell_background_gdk | ( |  | ) |

Cell background color as a GdkColor.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Gdk::Color > Gtk::CellRenderer::property_cell_background_gdk | ( |  | ) | const

Cell background color as a GdkColor.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< Gdk::RGBA > Gtk::CellRenderer::property_cell_background_rgba | ( |  | ) |

Cell background color as a GdkRGBA.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< Gdk::RGBA > Gtk::CellRenderer::property_cell_background_rgba | ( |  | ) | const

Cell background color as a GdkRGBA.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::CellRenderer::property_cell_background_set | ( |  | ) |

Whether the cell background color is set.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::CellRenderer::property_cell_background_set | ( |  | ) | const

Whether the cell background color is set.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::CellRenderer::property_editing | ( |  | ) | const

Whether the cell renderer is currently in editing mode.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< int > Gtk::CellRenderer::property_height | ( |  | ) |

The fixed height.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< int > Gtk::CellRenderer::property_height | ( |  | ) | const

The fixed height.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::CellRenderer::property_is_expanded | ( |  | ) |

Row is an expander row, and is expanded.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::CellRenderer::property_is_expanded | ( |  | ) | const

Row is an expander row, and is expanded.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::CellRenderer::property_is_expander | ( |  | ) |

Row has children.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::CellRenderer::property_is_expander | ( |  | ) | const

Row has children.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< CellRendererMode > Gtk::CellRenderer::property_mode | ( |  | ) |

Editable mode of the CellRenderer.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< CellRendererMode > Gtk::CellRenderer::property_mode | ( |  | ) | const

Editable mode of the CellRenderer.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::CellRenderer::property_sensitive | ( |  | ) |

Display the cell sensitive.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::CellRenderer::property_sensitive | ( |  | ) | const

Display the cell sensitive.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< bool > Gtk::CellRenderer::property_visible | ( |  | ) |

Display the cell.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< bool > Gtk::CellRenderer::property_visible | ( |  | ) | const

Display the cell.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< int > Gtk::CellRenderer::property_width | ( |  | ) |

The fixed width.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< int > Gtk::CellRenderer::property_width | ( |  | ) | const

The fixed width.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< float > Gtk::CellRenderer::property_xalign | ( |  | ) |

The x-align.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< float > Gtk::CellRenderer::property_xalign | ( |  | ) | const

The x-align.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< unsigned int > Gtk::CellRenderer::property_xpad | ( |  | ) |

The xpad.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< unsigned int > Gtk::CellRenderer::property_xpad | ( |  | ) | const

The xpad.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< float > Gtk::CellRenderer::property_yalign | ( |  | ) |

The y-align.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< float > Gtk::CellRenderer::property_yalign | ( |  | ) | const

The y-align.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy< unsigned int > Gtk::CellRenderer::property_ypad | ( |  | ) |

The ypad.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

Glib::PropertyProxy_ReadOnly< unsigned int > Gtk::CellRenderer::property_ypad | ( |  | ) | const

The ypad.

You rarely need to use properties because there are get_ and set_ methods for almost all of them.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

void Gtk::CellRenderer::render | ( | const ::Cairo::RefPtr< ::Cairo::Context > & | cr,
|  | Widget& | widget,
|  | const Gdk::Rectangle& | background_area,
|  | const Gdk::Rectangle& | cell_area,
|  | CellRendererState | flags
| ) |  |

Invokes the virtual render function of the Gtk::CellRenderer.

The three passed-in rectangles are areas in cr. Most renderers will draw within cell_area; the xalign, yalign, xpad, and ypad fields of the Gtk::CellRenderer should be honored with respect to cell_area. background_area includes the blank space around the cell, and also the area containing the tree expander; so the background_area rectangles for all cells tile to cover the entire window.

Parameters

  cr | A cairo context to draw to.
  widget | The widget owning window.
  background_area | Entire cell area (including tree expanders and maybe padding on the sides).
  cell_area | Area normally rendered by a cell renderer.
  flags | Flags that affect rendering.

virtual void Gtk::CellRenderer::render_vfunc | ( | const ::Cairo::RefPtr< ::Cairo::Context > & | cr,
|  | Widget& | widget,
|  | const Gdk::Rectangle& | background_area,
|  | const Gdk::Rectangle& | cell_area,
|  | CellRendererState | flags
| ) |  |

protected virtual

void Gtk::CellRenderer::set_alignment | ( | float | xalign,
|  | float | yalign
| ) |  |

Sets the renderer's alignment within its available space.

Since gtkmm 2.18:

Parameters

  xalign | The x alignment of the cell renderer.
  yalign | The y alignment of the cell renderer.

void Gtk::CellRenderer::set_fixed_size | ( | int | width,
|  | int | height
| ) |  |

Sets the renderer size to be explicit, independent of the properties set.

Parameters

  width | The width of the cell renderer, or -1.
  height | The height of the cell renderer, or -1.

void Gtk::CellRenderer::set_padding | ( | int | xpad,
|  | int | ypad
| ) |  |

Sets the renderer's padding.

Since gtkmm 2.18:

Parameters

  xpad | The x padding of the cell renderer.
  ypad | The y padding of the cell renderer.

void Gtk::CellRenderer::set_sensitive | ( | bool | sensitive = `true` | ) |

Sets the cell renderer's sensitivity.

Since gtkmm 2.18:

Parameters

  sensitive | The sensitivity of the cell.

void Gtk::CellRenderer::set_visible | ( | bool | visible = `true` | ) |

Sets the cell renderer's visibility.

Since gtkmm 2.18:

Parameters

  visible | The visibility of the cell.

Glib::SignalProxy0< void > Gtk::CellRenderer::signal_editing_canceled | ( |  | ) |

Slot Prototype:
  `void on_my_editing_canceled()`

This signal gets emitted when the user cancels the process of editing a cell. For example, an editable cell renderer could be written to cancel editing when the user presses Escape.

See also: Gtk::CellRenderer::stop_editing().

Since gtkmm 2.4:

Glib::SignalProxy2< void,CellEditable*,const Glib::ustring& > Gtk::CellRenderer::signal_editing_started | ( |  | ) |

Note that this signal does not work yet in gtkmm.

See http://bugzilla.gnome.org/show_bug.cgi?id=301597

Slot Prototype:
  `void on_my_editing_started(CellEditable* editable, const Glib::ustring& path)`

This signal gets emitted when a cell starts to be edited. The intended use of this signal is to do special setup on editable, e.g. adding a Gtk::EntryCompletion or setting up additional columns in a Gtk::ComboBox.

Note that GTK+ doesn't guarantee that cell renderers will continue to use the same kind of widget for editing in future releases, therefore you should check the type of editable before doing any specific setup, as in the following example:

[C example ellipted]

Since gtkmm 2.6:

Parameters

  editable | The Gtk::CellEditable.
  path | The path identifying the edited cell.

CellEditable* Gtk::CellRenderer::start_editing | ( | GdkEvent * | event,
|  | Widget& | widget,
|  | const Glib::ustring & | path,
|  | const Gdk::Rectangle& | background_area,
|  | const Gdk::Rectangle& | cell_area,
|  | CellRendererState | flags = `CellRendererState(0)`
| ) |  |

Passes an activate event to the cell renderer for possible processing.

Parameters

  event | A Gdk::Event.
  widget | Widget that received the event.
  path | Widget-dependent string representation of the event location; e.g. for Gtk::TreeView, a string representation of Gtk::TreePath.
  background_area | Background area as passed to render().
  cell_area | Cell area as passed to render().
  flags | Render flags.

Returns
  A new Gtk::CellEditable, or `0`.

virtual CellEditable* Gtk::CellRenderer::start_editing_vfunc | ( | GdkEvent * | event,
|  | Widget& | widget,
|  | const Glib::ustring & | path,
|  | const Gdk::Rectangle& | background_area,
|  | const Gdk::Rectangle& | cell_area,
|  | CellRendererState | flags
| ) |  |

protected virtual

void Gtk::CellRenderer::stop_editing | ( | bool | canceled = `false` | ) |

Informs the cell renderer that the editing is stopped.

If canceled is `true`, the cell renderer will emit the Gtk::CellRenderer::signal_editing_canceled() signal.

This function should be called by cell renderer implementations in response to the Gtk::CellEditable::signal_editing_done() signal of Gtk::CellEditable.

Since gtkmm 2.6:

Parameters

  canceled | `true` if the editing has been canceled.

## Friends And Related Function Documentation

Gtk::CellRenderer* wrap | ( | GtkCellRenderer * | object,
|  | bool | take_copy = `false`
| ) |  |

related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gtkmm/cellrenderer.h